## mupen64plus-video-z64 2.0.0+13+g72af4f0

=== projects/unix/Makefile ===
#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
# *   Mupen64plus-video-z64 - Makefile                                      *
# *   https://github.com/mupen64plus/mupen64plus-video-z64/                 *
# *   Copyright (C) 2010 Jon Ring                                           *
# *   Copyright (C) 2007-2009 Richard Goedeken                              *
# *   Copyright (C) 2007-2008 DarkJeztr Tillin9                             *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.          *
# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
# Makefile for Z64 Video plugin in Mupen64Plus

# detect operating system
UNAME ?= $(shell uname -s)
OS := NONE
ifeq ("$(UNAME)","Linux")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","linux")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifneq ("$(filter GNU hurd,$(UNAME))","")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","Darwin")
  OS = OSX
  SO_EXTENSION = dylib
  SHARED = -bundle
endif
ifeq ("$(UNAME)","FreeBSD")
  OS = FREEBSD
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","OpenBSD")
  OS = FREEBSD
  SO_EXTENSION = so
  SHARED = -shared
  $(warning OS type "$(UNAME)" not officially supported.')
endif
ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(patsubst MINGW%,MINGW,$(UNAME))","MINGW")
  OS = MINGW
  SO_EXTENSION = dll
  SHARED = -shared
  PIC = 0
endif
ifeq ("$(OS)","NONE")
  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# detect system architecture
HOST_CPU ?= $(shell uname -m)
CPU := NONE
ifneq ("$(filter x86_64 amd64,$(HOST_CPU))","")
  CPU := X86
  ifeq ("$(BITS)", "32")
    ARCH_DETECTED := 64BITS_32
    PIC ?= 0
  else
    ARCH_DETECTED := 64BITS
    PIC ?= 1
  endif
endif
ifneq ("$(filter pentium i%86,$(HOST_CPU))","")
  CPU := X86
  ARCH_DETECTED := 32BITS
  PIC ?= 0
endif
ifneq ("$(filter ppc macppc socppc powerpc,$(HOST_CPU))","")
  CPU := PPC
  ARCH_DETECTED := 32BITS
  BIG_ENDIAN := 1
  PIC ?= 1
  NO_ASM := 1
  $(warning Architecture "$(HOST_CPU)" not officially supported.')
endif
ifneq ("$(filter ppc64 powerpc64,$(HOST_CPU))","")
  CPU := PPC
  ARCH_DETECTED := 64BITS
  BIG_ENDIAN := 1
  PIC ?= 1
  NO_ASM := 1
  $(warning Architecture "$(HOST_CPU)" not officially supported.')
endif
ifneq ("$(filter arm%,$(HOST_CPU))","")
  ifeq ("$(filter arm%b,$(HOST_CPU))","")
    CPU := ARM
    ARCH_DETECTED := 32BITS
    PIC ?= 1
    NO_ASM := 1
    $(warning Architecture "$(HOST_CPU)" not officially supported.')
  endif
endif
ifeq ("$(CPU)","NONE")
  $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# base CFLAGS, LDLIBS, and LDFLAGS
OPTFLAGS ?= -O3 -flto
WARNFLAGS ?= -Wall
CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src
CXXFLAGS += -fvisibility-inlines-hidden
LDFLAGS += $(SHARED)

# Since we are building a shared library, we must compile with -fPIC on some architectures
# On 32-bit x86 systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
ifeq ($(PIC), 1)
  CFLAGS += -fPIC
else
  CFLAGS += -fno-PIC
endif

ifeq ($(BIG_ENDIAN), 1)
  CFLAGS += -DM64P_BIG_ENDIAN
endif

# tweak flags for 32-bit build on 64-bit system
ifeq ($(ARCH_DETECTED), 64BITS_32)
  ifeq ($(OS), FREEBSD)
    $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
  endif
  CFLAGS += -m32
  LDFLAGS += -Wl,-m,elf_i386
endif

# set special flags per-system
ifeq ($(OS), LINUX)
  # only export api symbols
  LDFLAGS += -Wl,-version-script,$(SRCDIR)/video_api_export.ver
endif
ifeq ($(OS), OSX)
  # Select the proper SDK
  # Also, SDKs are stored in a different location since XCode 4.3
  OSX_SDK ?= $(shell sw_vers -productVersion | cut -f1 -f2 -d .)
  OSX_XCODEMAJ = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f1 -d .)
  OSX_XCODEMIN = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f2 -d .)
  OSX_XCODEGE43 = $(shell echo "`expr $(OSX_XCODEMAJ) \>= 4``expr $(OSX_XCODEMIN) \>= 3`")
  ifeq ($(OSX_XCODEGE43), 11)
    OSX_SYSROOT := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs
  else
    OSX_SYSROOT := /Developer/SDKs
  endif

  ifeq ($(CPU), X86)
    ifeq ($(ARCH_DETECTED), 64BITS)
      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
      LDFLAGS += -bundle
      LDLIBS += -ldl
    else
      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
      LDFLAGS += -bundle
      LDLIBS += -ldl
    endif
  endif
endif
ifeq ($(OS), LINUX)
  LDLIBS += -ldl
endif
ifeq ($(OS), FREEBSD)
  LDLIBS += -lc
endif

# test for essential build dependencies
ifeq ($(origin PKG_CONFIG), undefined)
  PKG_CONFIG = $(CROSS_COMPILE)pkg-config
  ifeq ($(shell which $(PKG_CONFIG) 2>/dev/null),)
    $(error $(PKG_CONFIG) not found)
  endif
endif

ifeq ($(origin GLEW_CFLAGS) $(origin GLEW_LDLIBS), undefined undefined)
  ifeq ($(shell $(PKG_CONFIG) --modversion glew 2>/dev/null),)
    $(error No GLEW development libraries found!)
  endif
  GLEW_CFLAGS += $(shell $(PKG_CONFIG) --cflags glew)
  GLEW_LDLIBS +=  $(shell $(PKG_CONFIG) --libs glew)
endif
CFLAGS += $(GLEW_CFLAGS)
LDLIBS += $(GLEW_LDLIBS)

# search for OpenGL libraries
ifeq ($(OS), OSX)
  GL_LDLIBS = -framework OpenGL
endif
ifeq ($(OS), MINGW)
  GL_LDLIBS = -lopengl32
endif
ifeq ($(origin GL_CFLAGS) $(origin GL_LDLIBS), undefined undefined)
  ifeq ($(shell $(PKG_CONFIG) --modversion gl 2>/dev/null),)
    $(error No OpenGL development libraries found!)
  endif
  GL_CFLAGS += $(shell $(PKG_CONFIG) --cflags gl)
  GL_LDLIBS +=  $(shell $(PKG_CONFIG) --libs gl)
endif
CFLAGS += $(GL_CFLAGS)
LDLIBS += $(GL_LDLIBS)

# test for presence of SDL
ifeq ($(origin SDL_CFLAGS) $(origin SDL_LDLIBS), undefined undefined)
  SDL_CONFIG = $(CROSS_COMPILE)sdl-config
  ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
    $(error No SDL development libraries found!)
  endif
  ifeq ($(OS),OSX)
    SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
    # sdl-config on mac screws up when we're trying to build a library and not an executable
    # SDL 1.3 is supposed to fix that, if it's ever released
    SDL_LDLIBS += -L/usr/local/lib -lSDL -Wl,-framework,Cocoa
  else
    SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
    SDL_LDLIBS += $(shell $(SDL_CONFIG) --libs)
  endif
endif
CFLAGS += $(SDL_CFLAGS)
LDLIBS += $(SDL_LDLIBS)

# set mupen64plus core API header path
ifneq ("$(APIDIR)","")
  CFLAGS += "-I$(APIDIR)"
else
  TRYDIR = ../../../mupen64plus-core/src/api
  ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
    CFLAGS += -I$(TRYDIR)
  else
    TRYDIR = /usr/local/include/mupen64plus
    ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
      CFLAGS += -I$(TRYDIR)
    else
      TRYDIR = /usr/include/mupen64plus
      ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
        CFLAGS += -I$(TRYDIR)
      else
        $(error Mupen64Plus API header files not found! Use makefile parameter APIDIR to force a location.)
      endif
    endif
  endif
endif

# reduced compile output when running make without V=1
ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
	Q_CC  = @echo '    CC  '$@;
	Q_CXX = @echo '    CXX '$@;
	Q_LD  = @echo '    LD  '$@;
endif
endif

# set base program pointers and flags
CC        = $(CROSS_COMPILE)gcc
CXX       = $(CROSS_COMPILE)g++
RM       ?= rm -f
INSTALL  ?= install
MKDIR ?= mkdir -p
COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
COMPILE.cc = $(Q_CXX)$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
LINK.o = $(Q_LD)$(CXX) $(CXXFLAGS) $(LDFLAGS) $(TARGET_ARCH)

# set special flags for given Makefile parameters
ifeq ($(DEBUG),1)
  CFLAGS += -g
  INSTALL_STRIP_FLAG ?= 
else
  INSTALL_STRIP_FLAG ?= -s
endif

# set installation options
ifeq ($(PREFIX),)
  PREFIX := /usr/local
endif
ifeq ($(SHAREDIR),)
  SHAREDIR := $(PREFIX)/share/mupen64plus
endif
ifeq ($(LIBDIR),)
  LIBDIR := $(PREFIX)/lib
endif
ifeq ($(PLUGINDIR),)
  PLUGINDIR := $(LIBDIR)/mupen64plus
endif

SRCDIR = ../../src
OBJDIR = _obj$(POSTFIX)

# list of source files to compile
SOURCE = \
	$(SRCDIR)/rgl.cpp \
	$(SRCDIR)/rgl_settings.cpp \
	$(SRCDIR)/rgl_tiles.cpp \
	$(SRCDIR)/rgl_rendermode.cpp \
	$(SRCDIR)/rgl_geometry.cpp \
	$(SRCDIR)/rgl_debugger.cpp \
	$(SRCDIR)/rgl_osdep.cpp \
	$(SRCDIR)/rdp.cpp \
	$(SRCDIR)/glshader.cpp \
	$(SRCDIR)/disasm.cpp \
	$(SRCDIR)/maingl.cpp

ifeq ($(OS),MINGW)
SOURCE += $(SRCDIR)/osal_dynamiclib_win32.c
else
SOURCE += $(SRCDIR)/osal_dynamiclib_unix.c
endif

# generate a list of object files build, make a temporary directory for them
OBJECTS := $(patsubst $(SRCDIR)/%.c, $(OBJDIR)/%.o, $(filter %.c, $(SOURCE)))
OBJECTS += $(patsubst $(SRCDIR)/%.cpp, $(OBJDIR)/%.o, $(filter %.cpp, $(SOURCE)))
OBJDIRS = $(dir $(OBJECTS))
$(shell $(MKDIR) $(OBJDIRS))

# build targets
TARGET = mupen64plus-video-z64$(POSTFIX).$(SO_EXTENSION)

targets:
	@echo "Mupen64plus-video-z64 N64 Graphics plugin makefile. "
	@echo "  Targets:"
	@echo "    all           == Build Mupen64plus-video-z64 plugin"
	@echo "    clean         == remove object files"
	@echo "    rebuild       == clean and re-build all"
	@echo "    install       == Install Mupen64Plus-video-z64 plugin"
	@echo "    uninstall     == Uninstall Mupen64Plus-video-z64 plugin"
	@echo "  Options:"
	@echo "    BITS=32       == build 32-bit binaries on 64-bit machine"
	@echo "    APIDIR=path   == path to find Mupen64Plus Core headers"
	@echo "    OPTFLAGS=flag == compiler optimization (default: -O3 -flto)"
	@echo "    WARNFLAGS=flag == compiler warning levels (default: -Wall)"
	@echo "    PIC=(1|0)     == Force enable/disable of position independent code"
	@echo "    POSTFIX=name  == String added to the name of the the build (default: '')"
	@echo "  Install Options:"
	@echo "    PREFIX=path   == install/uninstall prefix (default: /usr/local)"
	@echo "    SHAREDIR=path == path to install shared data files (default: PREFIX/share/mupen64plus)"
	@echo "    LIBDIR=path   == library prefix (default: PREFIX/lib)"
	@echo "    PLUGINDIR=path == path to install plugin libraries (default: LIBDIR/mupen64plus)"
	@echo "    DESTDIR=path  == path to prepend to all installation paths (only for packagers)"
	@echo "  Debugging Options:"
	@echo "    DEBUG=1       == add debugging symbols"
	@echo "    V=1           == show verbose compiler output"

all: $(TARGET)

install: $(TARGET)
	$(INSTALL) -d "$(DESTDIR)$(PLUGINDIR)"
	$(INSTALL) -m 0644 $(INSTALL_STRIP_FLAG) $(TARGET) "$(DESTDIR)$(PLUGINDIR)"

=== debian/changelog ===
mupen64plus-video-z64 (2.0.0+13+g72af4f0-9) unstable; urgency=medium

  [ Sven Eckelmann ]
  * debian/control:
    - Upgraded to policy 4.6.1, no changes required
    - Allow build without (fake)root
    - Switch default Vcs-Git branch to debian/unstable
    - Switch to debhelper compat 13
    - Remove versioned constraints unnecessary since buster
    - Use secure URI in Homepage field
    - Replace Build-Depends libgl1-mesa-dev with libgl-dev
  * debian/copyright
    - Update copyright years to 2022
  * Drop duplicated fields from upstream/metadata
  * Update debian/watch for format 4
  * debian/rules:
    - Drop default flag --as-needed from linker flags
  * Remove constraints unnecessary since buster (oldstable):
    + mupen64plus-video-z64: Drop versioned constraint on libmupen64plus2 in
      Breaks.
  * Remove unused lintian override spelling-error-in-binary

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Remove overrides for lintian tags that are no longer supported.

 -- Sven Eckelmann <sven@narfation.org>  Mon, 14 Nov 2022 19:08:13 +0100

mupen64plus-video-z64 (2.0.0+13+g72af4f0-8) unstable; urgency=medium

  * debian/control
    - Automatically select correct Vcs-Git branch
    - Upgraded to policy 4.4.0, no changes required
    - Switch to debhelper 12
  * debian/rules
    - Allow one to override pkg-config for crossbuilds
  * debian/copyright
    - Update copyright years to 2019

 -- Sven Eckelmann <sven@narfation.org>  Wed, 28 Aug 2019 00:20:25 +0200

mupen64plus-video-z64 (2.0.0+13+g72af4f0-7) unstable; urgency=medium

  * debian/patches:
    - Add Replace-glext-with-glew.patch, Replace glext with glew
      (Closes: #915624)

 -- Sven Eckelmann <sven@narfation.org>  Wed, 05 Dec 2018 15:05:56 +0100

mupen64plus-video-z64 (2.0.0+13+g72af4f0-6) unstable; urgency=medium

  * Upgraded to policy 4.2.1
    - remove get-orig-source rule from debian/rules
  * Fix lintian overrides on i386
  * debian/copyright:
    - Update copyright years
  * debian/control:
    - update to debhelper 10
    - Move VCS-* to salsa.debian.org
  * debian/rules
    - Remove ddeb migration conflict against pre-stretch package
    - Drop (now default) parameter --parallel for dch

 -- Sven Eckelmann <sven@narfation.org>  Thu, 18 Oct 2018 21:56:58 +0200

mupen64plus-video-z64 (2.0.0+13+g72af4f0-5) unstable; urgency=medium

  * debian/control
    - Change Vcs-Git to https://
  * debian/patches:
    - Add Fix-spelling-errors.patch, Fix spelling errors
  * Override the lintian warning about spelling error
  * Sort debian control files with `wrap-and-sort -abst`

 -- Sven Eckelmann <sven@narfation.org>  Sun, 31 Jan 2016 18:08:37 +0100

mupen64plus-video-z64 (2.0.0+13+g72af4f0-4) unstable; urgency=medium

  * debian/control, debian/rules:
     - Drop mupen64plus-video-z64-dbg in favor of -dbgsym package
  * debian/patches:
    - Add Don-t-create-empty-directory-for-shared-data-files.patch,
      Don't create empty directory for shared data files
  * Update copyright years in debian/copyright
  * Override the lintian warning about missing upstream changelog

 -- Sven Eckelmann <sven@narfation.org>  Fri, 01 Jan 2016 14:10:35 +0100

mupen64plus-video-z64 (2.0.0+13+g72af4f0-3) unstable; urgency=medium

  * debian/control:
    - Move Vcs URLs from collab-maint to pkg-games
    - Update upstream URLs
    - Set Maintainer to Debian Games Team

 -- Sven Eckelmann <sven@narfation.org>  Thu, 26 Nov 2015 07:52:55 +0100

mupen64plus-video-z64 (2.0.0+13+g72af4f0-2) unstable; urgency=medium

  * debian/patches:
    - Add glew_include.patch, Fix glew >= 1.12 includes (Closes: #791401)
    - Move patches to alternative DEP-3 format and manage them with gbp pq

 -- Sven Eckelmann <sven@narfation.org>  Sat, 04 Jul 2015 14:10:46 +0200

mupen64plus-video-z64 (2.0.0+13+g72af4f0-1) unstable; urgency=medium

  * New Upstream Snapshot from 72af4f0f9c508b8e6ba84b210f81b634c1a2480d
  * Upload to unstable
  * debian/control:
    - Upgraded to policy 3.9.6, no changes required
    - Change Vcs-Browser to new alioth CGit URL
  * debian/copyright:
    - Rewrite copyright information
    - Update years in debian/copyright

 -- Sven Eckelmann <sven@narfation.org>  Sat, 02 May 2015 14:16:21 +0200

mupen64plus-video-z64 (2.0.0+9+gb0a0b5f-1) experimental; urgency=medium

  * New Upstream Snapshot from b0a0b5f999e8a115f8d0301d38f85d0e5032e0a7

 -- Sven Eckelmann <sven@narfation.org>  Fri, 05 Sep 2014 12:33:01 +0200

mupen64plus-video-z64 (2.0.0-2) unstable; urgency=low

  * Upgraded to policy 3.9.5, no changes required
  * debian/watch:
    - Change upstream check from bitbucket to github
  * debian/copyright:
    - Change upstream source to github
  * debian/get-orig-source.sh
    - Change upstream repository to github
    - Change SCM from Mercurial to Git
  * Update copyright years in debian/copyright
  * Move keyring for signature verification to new debian/upstream/
  * debian/rules:
    - Use Largefile Support enabled C API

 -- Sven Eckelmann <sven@narfation.org>  Sat, 30 Aug 2014 16:26:30 +0200

=== debian/control ===
Source: mupen64plus-video-z64
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Sven Eckelmann <sven@narfation.org>,
 Tobias Loose <TobiasLoose@gmx.de>,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://mupen64plus.org/
Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-video-z64.git -b debian/unstable
Vcs-Browser: https://salsa.debian.org/games-team/mupen64plus-video-z64
Build-Depends:
 debhelper-compat (= 13),
 libgl-dev,
 libglew-dev,
 libmupen64plus-dev,
 libsdl2-dev,
 pkg-config,

Package: mupen64plus-video-z64
Architecture: any-amd64 any-i386
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 mupen64plus-config-abi-2.2,
 mupen64plus-gfx-abi-2.2,
 mupen64plus-rsp-z64,
 mupen64plus-vidext-abi-3,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 mupen64plus-video,
Description: low-level rdp emulation for mupen64plus
 N64 Reality Drawing Processor emulation which can be used with a low-level
 rsp emulation plugin like mupen64plus-rsp-z64. It can emulate even unknown or
 uncommon microcodes, but cannot benefit from faster implementation for the
 host cpu.
 .
 A fast processor and graphics hardware which supports vertex and fragment
 shader is needed for this plugin.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildtools.mk

export PKG_CONFIG ?= pkg-config
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_CFLAGS_MAINT_APPEND=-flto
export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG" SDL_CONFIG=sdl2-config

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix"

override_dh_auto_test:
	# otherwise dh_auto_test fails with debhelper 9.20130624

override_dh_auto_clean:
	dh_auto_clean -- $(MAKEOPTIONS)

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	override_dh_auto_clean override_dh_auto_test override_dh_auto_build override_dh_auto_install

## mupen64plus-video-z64 2.5.9

=== projects/unix/Makefile ===
--- 
+++ 
@@ -54,7 +54,6 @@
   OS = FREEBSD
   SO_EXTENSION = so
   SHARED = -shared
-  $(warning OS type "$(UNAME)" not officially supported.')
 endif
 ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
   OS = LINUX
@@ -68,7 +67,7 @@
   PIC = 0
 endif
 ifeq ("$(OS)","NONE")
-  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
+  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'https://github.com/mupen64plus/mupen64plus-core/issues')
 endif
 
 # detect system architecture
@@ -115,7 +114,7 @@
   endif
 endif
 ifeq ("$(CPU)","NONE")
-  $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
+  $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'https://github.com/mupen64plus/mupen64plus-core/issues')
 endif
 
 # base CFLAGS, LDLIBS, and LDFLAGS
@@ -220,16 +219,25 @@
 
 # test for presence of SDL
 ifeq ($(origin SDL_CFLAGS) $(origin SDL_LDLIBS), undefined undefined)
-  SDL_CONFIG = $(CROSS_COMPILE)sdl-config
+  SDL_CONFIG = $(CROSS_COMPILE)sdl2-config
   ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
-    $(error No SDL development libraries found!)
-  endif
-  ifeq ($(OS),OSX)
-    SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
-    # sdl-config on mac screws up when we're trying to build a library and not an executable
-    # SDL 1.3 is supposed to fix that, if it's ever released
-    SDL_LDLIBS += -L/usr/local/lib -lSDL -Wl,-framework,Cocoa
+    SDL_CONFIG = $(CROSS_COMPILE)sdl-config
+    ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
+      $(error No SDL development libraries found!)
+    else
+      $(warning Using SDL 1.2 libraries)
+      ifeq ($(OS),OSX)
+        SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
+        # sdl-config on mac screws up when we're trying to build a library and not an executable
+        # SDL 1.3 is supposed to fix that, if it's ever released
+        SDL_LDLIBS += -L/usr/local/lib -lSDL -Wl,-framework,Cocoa
+      else
+        SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
+        SDL_LDLIBS += $(shell $(SDL_CONFIG) --libs)
+      endif
+    endif
   else
+    #SDL2 detected
     SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
     SDL_LDLIBS += $(shell $(SDL_CONFIG) --libs)
   endif
@@ -354,11 +362,3 @@
 	@echo "    PLUGINDIR=path == path to install plugin libraries (default: LIBDIR/mupen64plus)"
 	@echo "    DESTDIR=path  == path to prepend to all installation paths (only for packagers)"
 	@echo "  Debugging Options:"
-	@echo "    DEBUG=1       == add debugging symbols"
-	@echo "    V=1           == show verbose compiler output"
-
-all: $(TARGET)
-
-install: $(TARGET)
-	$(INSTALL) -d "$(DESTDIR)$(PLUGINDIR)"
-	$(INSTALL) -m 0644 $(INSTALL_STRIP_FLAG) $(TARGET) "$(DESTDIR)$(PLUGINDIR)"

=== debian/changelog ===
mupen64plus-video-z64 (2.5.9-1) experimental; urgency=medium

  * New Upstream Version
  * Verify new upstream versions using GPG key 954F81B094AA5BB226F5
  * debian/rules
    - Allow one to override pkg-config for crossbuilds
  * debian/control
    - Upgraded to policy 4.3.0, no changes required
    - Switch to debhelper 12
  * debian/copyright
    - Update copyright years to 2019

 -- Sven Eckelmann <sven@narfation.org>  Sat, 02 Mar 2019 20:17:10 +0100

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,16 @@
 Uploaders:
  Sven Eckelmann <sven@narfation.org>,
  Tobias Loose <TobiasLoose@gmx.de>,
-Standards-Version: 4.6.1
-Rules-Requires-Root: no
-Homepage: https://mupen64plus.org/
-Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-video-z64.git -b debian/unstable
+Standards-Version: 4.3.0
+Homepage: http://mupen64plus.org/
+Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-video-z64.git
 Vcs-Browser: https://salsa.debian.org/games-team/mupen64plus-video-z64
 Build-Depends:
- debhelper-compat (= 13),
- libgl-dev,
+ debhelper (>= 12),
+ dpkg-dev (>= 1.16.1.1),
+ libgl1-mesa-dev | libgl-dev,
  libglew-dev,
- libmupen64plus-dev,
+ libmupen64plus-dev (>= 2.0),
  libsdl2-dev,
  pkg-config,
 
@@ -32,6 +32,8 @@
  ${shlibs:Depends},
 Provides:
  mupen64plus-video,
+Breaks:
+ libmupen64plus2 (<< 2.0),
 Description: low-level rdp emulation for mupen64plus
  N64 Reality Drawing Processor emulation which can be used with a low-level
  rsp emulation plugin like mupen64plus-rsp-z64. It can emulate even unknown or

## mupen64plus-video-z64 2.5.9%2B9%2Bg5dba5bd

=== debian/changelog ===
mupen64plus-video-z64 (2.5.9+9+g5dba5bd-2) unstable; urgency=medium

  * debian/rules:
    - disallow compiler to drop code related to signed integer overflows during
      optimization
  * debian/control:
    - Upgraded to policy 4.6.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 31 Dec 2022 19:00:23 +0100

mupen64plus-video-z64 (2.5.9+9+g5dba5bd-1) unstable; urgency=medium

  * New Upstream Snapshot from 5dba5bd533911b0306dfad7349f0ed96bf47ec76
  * Upload to unstable

 -- Sven Eckelmann <sven@narfation.org>  Tue, 15 Nov 2022 12:58:14 +0100

## mupen64plus-video-z64 2.5.9+9+g5dba5bd

=== projects/unix/Makefile ===
--- 
+++ 
@@ -141,8 +141,20 @@
   ifeq ($(OS), FREEBSD)
     $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
   endif
-  CFLAGS += -m32
-  LDFLAGS += -Wl,-m,elf_i386
+  ifneq ($(OS), OSX)
+    ifeq ($(OS), MINGW)
+      LDFLAGS += -Wl,-m,i386pe
+    else
+      CFLAGS += -m32
+      LDFLAGS += -Wl,-m,elf_i386
+    endif
+  endif
+endif
+
+ifeq ($(ARCH_DETECTED), 64BITS)
+  ifeq ($(OS), MINGW)
+    LDFLAGS += -Wl,-m,i386pep
+  endif
 endif
 
 # set special flags per-system
@@ -359,6 +371,3 @@
 	@echo "    PREFIX=path   == install/uninstall prefix (default: /usr/local)"
 	@echo "    SHAREDIR=path == path to install shared data files (default: PREFIX/share/mupen64plus)"
 	@echo "    LIBDIR=path   == library prefix (default: PREFIX/lib)"
-	@echo "    PLUGINDIR=path == path to install plugin libraries (default: LIBDIR/mupen64plus)"
-	@echo "    DESTDIR=path  == path to prepend to all installation paths (only for packagers)"
-	@echo "  Debugging Options:"

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,16 @@
 Uploaders:
  Sven Eckelmann <sven@narfation.org>,
  Tobias Loose <TobiasLoose@gmx.de>,
-Standards-Version: 4.3.0
-Homepage: http://mupen64plus.org/
-Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-video-z64.git
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Homepage: https://mupen64plus.org/
+Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-video-z64.git -b debian/unstable
 Vcs-Browser: https://salsa.debian.org/games-team/mupen64plus-video-z64
 Build-Depends:
- debhelper (>= 12),
- dpkg-dev (>= 1.16.1.1),
- libgl1-mesa-dev | libgl-dev,
+ debhelper-compat (= 13),
+ libgl-dev,
  libglew-dev,
- libmupen64plus-dev (>= 2.0),
+ libmupen64plus-dev,
  libsdl2-dev,
  pkg-config,
 
@@ -32,8 +32,6 @@
  ${shlibs:Depends},
 Provides:
  mupen64plus-video,
-Breaks:
- libmupen64plus2 (<< 2.0),
 Description: low-level rdp emulation for mupen64plus
  N64 Reality Drawing Processor emulation which can be used with a low-level
  rsp emulation plugin like mupen64plus-rsp-z64. It can emulate even unknown or

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,10 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
 export DEB_CFLAGS_MAINT_APPEND=-flto
 export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
+
+# mupen64plus and its plugins sometimes use signed integer overflows
+# the compiler must not optimize them away due to their "undefined behavior"
+DEB_CFLAGS_MAINT_APPEND=-fno-aggressive-loop-optimizations -fno-strict-overflow
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)

=== debian/watch ===
version=4

opts="pgpsigurlmangle=s/$/.asc/" \
 https://github.com/mupen64plus/mupen64plus-video-z64/releases \
	/mupen64plus/mupen64plus-video-z64/releases/download/[^/]+/mupen64plus-video-z64-src-(.*\d).tar.gz

## mupen64plus-video-z64 2.6.0

=== projects/unix/Makefile ===
--- 
+++ 
@@ -117,6 +117,9 @@
   $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'https://github.com/mupen64plus/mupen64plus-core/issues')
 endif
 
+SRCDIR = ../../src
+OBJDIR = _obj$(POSTFIX)
+
 # base CFLAGS, LDLIBS, and LDFLAGS
 OPTFLAGS ?= -O3 -flto
 WARNFLAGS ?= -Wall
@@ -161,6 +164,10 @@
 ifeq ($(OS), LINUX)
   # only export api symbols
   LDFLAGS += -Wl,-version-script,$(SRCDIR)/video_api_export.ver
+  LDLIBS += -ldl
+endif
+ifeq ($(OS), FREEBSD)
+  LDLIBS += -lc
 endif
 ifeq ($(OS), OSX)
   # Select the proper SDK
@@ -186,12 +193,6 @@
       LDLIBS += -ldl
     endif
   endif
-endif
-ifeq ($(OS), LINUX)
-  LDLIBS += -ldl
-endif
-ifeq ($(OS), FREEBSD)
-  LDLIBS += -lc
 endif
 
 # test for essential build dependencies
@@ -310,18 +311,12 @@
 ifeq ($(PREFIX),)
   PREFIX := /usr/local
 endif
-ifeq ($(SHAREDIR),)
-  SHAREDIR := $(PREFIX)/share/mupen64plus
-endif
 ifeq ($(LIBDIR),)
   LIBDIR := $(PREFIX)/lib
 endif
 ifeq ($(PLUGINDIR),)
   PLUGINDIR := $(LIBDIR)/mupen64plus
 endif
-
-SRCDIR = ../../src
-OBJDIR = _obj$(POSTFIX)
 
 # list of source files to compile
 SOURCE = \
@@ -369,5 +364,6 @@
 	@echo "    POSTFIX=name  == String added to the name of the the build (default: '')"
 	@echo "  Install Options:"
 	@echo "    PREFIX=path   == install/uninstall prefix (default: /usr/local)"
-	@echo "    SHAREDIR=path == path to install shared data files (default: PREFIX/share/mupen64plus)"
 	@echo "    LIBDIR=path   == library prefix (default: PREFIX/lib)"
+	@echo "    PLUGINDIR=path == path to install plugin libraries (default: LIBDIR/mupen64plus)"
+	@echo "    DESTDIR=path  == path to prepend to all installation paths (only for packagers)"

=== debian/changelog ===
mupen64plus-video-z64 (2.6.0-2) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.7.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 01 Mar 2025 20:58:04 +0100

mupen64plus-video-z64 (2.6.0-1) unstable; urgency=medium

  * New Upstream Version
  * debian/rules:
    - Use DEB_BUILD_MAINT_OPTIONS to set lto flags
    - Use DEB_BUILD_MAINT_OPTIONS to set lfs flag
  * debian/control:
    - Replace pkg-config with pkgconf
  * debian/watch:
    - Switch to api.github.com to check for releases

 -- Sven Eckelmann <sven@narfation.org>  Mon, 15 Jul 2024 10:27:52 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Sven Eckelmann <sven@narfation.org>,
  Tobias Loose <TobiasLoose@gmx.de>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://mupen64plus.org/
 Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-video-z64.git -b debian/unstable
@@ -16,7 +16,7 @@
  libglew-dev,
  libmupen64plus-dev,
  libsdl2-dev,
- pkg-config,
+ pkgconf,
 
 Package: mupen64plus-video-z64
 Architecture: any-amd64 any-i386

=== debian/rules ===
--- 
+++ 
@@ -4,9 +4,7 @@
 -include /usr/share/dpkg/buildtools.mk
 
 export PKG_CONFIG ?= pkg-config
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
-export DEB_CFLAGS_MAINT_APPEND=-flto
-export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie optimize=+lto abi=+lfs
 
 # mupen64plus and its plugins sometimes use signed integer overflows
 # the compiler must not optimize them away due to their "undefined behavior"
